//---------------------------------------------------------------------------

#include <vcl.h>
#include <cmath>
#pragma hdrstop

#include "MoonClockUnit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
AnsiString houiMess(double houi_kaku)
{
  struct hougakuSetType
  {
    char *from;
    char *to;
    char *zeroSide;
    char *fulSide;
    bool isReverse;
  };

  hougakuSetType hougakuSet[] =
  {
    {"k", "", "k",   "k", false},  // 0 ->   0.. 45
    {"", "k", "k", "",   true},   // 1 ->  45.. 90
    {"", "", "",   "쓌", false},  // 2 ->  90..135
    {"", "", "쓌", "",   true},   // 3 -> 135..180

    {"", "", "",   "쐼", false},  // 4 -> 180..225
    {"", "", "쐼", "",   true},   // 5 -> 225..270
    {"", "k", "",   "k", false},  // 6 -> 270..315
    {"k", "", "k", "k",   true},   // 7 -> 315..360

    {"k", "", "k", "k",   true},   // 8 -> 360..360 \iA360xĂ܂j
  };

  const double dgreeUnit = 45;

  AnsiString result = "@";
  int phase = houi_kaku;
  phase /= dgreeUnit;
  double mod = std::fmod(houi_kaku, dgreeUnit);
  hougakuSetType *ptr = &hougakuSet[phase];

  if       (mod <= 0.5)  result += (ptr->zeroSide);
  else if  (mod >= dgreeUnit - 0.5) result += (ptr->fulSide);
  else
  {
	 if (ptr->isReverse) mod = dgreeUnit - mod;
     result += (ptr->from);
     result += "  ";
     result += AnsiString::FloatToStrF(mod, AnsiString::sffFixed, 4, 1);
     result += "x  ";
     result += (ptr->to);
  }

  result += " [";
  result += AnsiString::FloatToStrF(houi_kaku, AnsiString::sffFixed, 4, 1);
  result += "]";

  return result;
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  reDraw();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::reDraw()
{
   TDateTime now = Now();

   AnsiString title = "Moon Clock :";
   title += now.FormatString("yyyy-mm-dd hh:nn:ss");
   Form1->Caption = title;

   AnsiString line;

   KEIDO->Caption = AnsiString::FloatToStrF(chijou.keido, AnsiString::sffFixed, 6, 3);
   IDO->Caption   = AnsiString::FloatToStrF(chijou.ido, AnsiString::sffFixed, 6, 3);

   static int IndexNow = -1;

   if (MainTab->TabIndex != IndexNow)
   {
	 IndexNow = MainTab->TabIndex;
	 switch(IndexNow)
	 {
	   case 0: Form1->Icon->LoadFromFile("MoonClock_sun.ico");  break;
	   case 1: Form1->Icon->LoadFromFile("MoonClock_moon.ico"); break;
	 }
   }

   C_Gessou->Caption     = AnsiString::FloatToStrF(sun_moon(now).phase(), AnsiString::sffFixed, 5, 3);
   C_Getsurei->Caption   = AnsiString::FloatToStrF(sun_moon(now).age(), AnsiString::sffFixed, 5, 3);

   double houi;
   astro *ptr;

   switch(MainTab->TabIndex)
   {
	 case 0: ptr = new sun(now);  break;
	 case 1: ptr = new moon(now); break;
   }

   Koukei->Caption  = AnsiString::FloatToStrF(ptr->koudou_axis().keido, AnsiString::sffFixed, 6, 3);
   Koui->Caption    = AnsiString::FloatToStrF(ptr->koudou_axis().ido, AnsiString::sffFixed, 6, 3);
   Jikaku->Caption  = AnsiString::FloatToStrF(ptr->getJikaku(chijou), AnsiString::sffFixed, 6, 3);
   Sekkei->Caption  = AnsiString::FloatToStrF(ptr->sekidou_axis().keido, AnsiString::sffFixed, 6, 3);
   Sekii->Caption   = AnsiString::FloatToStrF(ptr->sekidou_axis().ido, AnsiString::sffFixed, 6, 3);

   houi = ptr->houi(chijou);
   Houi->Caption     = AnsiString::FloatToStrF(houi, AnsiString::sffFixed, 6, 3);
   Houi_Str->Caption = houiMess(houi);
   Koudo->Caption    = AnsiString::FloatToStrF(ptr->koudo(chijou), AnsiString::sffFixed, 6, 3);

   delete ptr;
   
   TDateTime kouseiTime = aTime::getKouseiJi(now, chijou) / 360;
   C_Kouseiji->Caption    = AnsiString::FloatToStrF(kouseiTime, AnsiString::sffFixed, 6, 3);
   C_Kouseiji_Time->Caption = kouseiTime.FormatString("hh:nn:ss");

   line = "Last: ";
   line += sun_moon(now).getLastNewMoon().FormatString("yyyy-mm-dd hh:nn:ss");
   C_NewMoon_Last->Caption = line;

   line = "Next: ";
   line += sun_moon(now).getNextNewMoon().FormatString("yyyy-mm-dd hh:nn:ss");
   C_NewMoon_Next->Caption = line;

   // ǒvZ

   static int dispIndex = -1;
   static TDateTime today = 0;
   if ((dispIndex == BashoSelect->ItemIndex) && (static_cast<int>(today) == static_cast<int>(now))) return;


   // óuČvZvKv

   dispIndex = BashoSelect->ItemIndex;
   today = static_cast<int>(now);

   TDateTime wk;

   JIKOKU_AKE->Caption  = sun(now).ake(chijou).FormatString("hh:nn:ss");

   wk = sun(now).de(chijou);
   JIKOKU_DE->Caption   = wk.FormatString("hh:nn:ss");
   HOUI_STR_DE->Caption = houiMess(sun(wk).houi(chijou));

   wk = sun(now).iri(chijou);
   JIKOKU_IRI->Caption   = wk.FormatString("hh:nn:ss");
   HOUI_STR_IRI->Caption = houiMess(sun(wk).houi(chijou));

   JIKOKU_KURE->Caption = sun(now).kure(chijou).FormatString("hh:nn:ss");


   wk = moon(now).de(chijou);
   JIKOKU_DE_MOON->Caption   = wk.FormatString("hh:nn:ss");
   HOUI_STR_DE_MOON->Caption = houiMess(moon(wk).houi(chijou));

   wk = moon(now).iri(chijou);
   JIKOKU_IRI_MOON->Caption   = wk.FormatString("hh:nn:ss");
   HOUI_STR_IRI_MOON->Caption = houiMess(moon(wk).houi(chijou));


}
//---------------------------------------------------------------------------





void __fastcall TForm1::MainTabChange(TObject *Sender)
{
   reDraw();
}
//---------------------------------------------------------------------------


#include <inifiles.hpp>

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  TStringList *aList = new TStringList;
  TIniFile *ini = new TIniFile("./MoonClock.ini");

  int index;

  ini->ReadSections(aList);
  if(aList->Find("SYSTEM", index))
  {
	aList->Delete(index); // [SYSTEM]  Xg폜
  }

  BashoSelect->Items = aList;
  BashoSelect->ItemIndex = ini->ReadInteger("SYSTEM", "INDEX", 0);

  delete ini;

  BashoSelectChange(0);
  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BashoSelectChange(TObject *Sender)
{

  static int back_ItemIndex = 0;

  if (BashoSelect->ItemIndex < 0) BashoSelect->ItemIndex = back_ItemIndex;
  AnsiString section = BashoSelect->Items->Strings[BashoSelect->ItemIndex];
  BashoSelect->Text = section;
  back_ItemIndex = BashoSelect->ItemIndex;

  TIniFile *ini = new TIniFile("./MoonClock.ini");
  chijou.ido   = ini->ReadFloat(section, "IDO", 35.4878);
  chijou.keido = ini->ReadFloat(section, "KEIDO", 133.8598);
  delete ini;

  reDraw();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  TIniFile *ini = new TIniFile("./MoonClock.ini");
  ini->WriteInteger("SYSTEM", "INDEX", BashoSelect->ItemIndex);
  delete ini;
}
//---------------------------------------------------------------------------

